/*
  Blank Simple Project.c
  http://learn.parallax.com/propeller-c-tutorials 
*/
#include "simpletools.h"                      // Include simple tools
#include "fdserial.h"




struct nmea{

char gpsname[6];
int gpstime[6];
char fix[1];
double lat;
char latchar[1];
double longitude;
char longchar[1];
double speed;
double track;
int date;
double magvar;
}gps;
char RMC[80]; //gps string 
char gpsraw;
char tempf[20];



char hrs[2];
char min[2];
char sec[2];
//forward declarations of functions used

void getdata2(); //receive data from gps
void parce_rmc();
void print_data(); 
void parce_time();
void print_full();
void init();

int index;


int rx_pin = 26;
int tx_pin = 27;
int mode_ = 0;
int Baud_rate = 9600;

fdserial *GPS;  //MASK FOR THE FDSERIAL INPUT
int main()                                    // Main function
{
    init();
    while(1)
    {
        // getdata();
        getdata2();
       // print_data();
        // print_data();
    } 
}  


void init()
{
#ifndef DEBUG
    GPS = fdserial_open(rx_pin,tx_pin,mode_ ,Baud_rate);
#endif
}


void getdata2()
{
    //read in characters from the GPS
    int idx = 0;
    do
    {
        gpsraw = fdserial_rxChar(GPS);
        RMC[idx++] = gpsraw;      
    } while(gpsraw != 13 && gpsraw != 10);
    RMC[idx] = 0;      //null terminate

    

    if(strncmp(RMC, "$GPRMC", 6) == 0)
    
    
        parce_rmc();
    
}



void parce_rmc()



   {
     
     //GPS SENTANCE NAME
            strcpy(gps.gpsname,strtok(RMC, ","));
            
            strcpy(gps.gpstime,strtok(NULL, ","));
             
            
            strncpy( gps.fix,strtok(NULL, ","),1); 
            
            
              gps.lat=atof(  strcpy( tempf,strtok(NULL, ",")));
              
             
             strcpy( gps.latchar,strtok(NULL, ",")); 
             
             
              gps.longitude=atof(  strcpy( tempf,strtok(NULL, ",")));
             
             
              strcpy( gps.longchar,strtok(NULL, ","));
              
              
              
               gps.speed = atof(  strcpy( tempf,strtok(NULL, ",")));
               
               
               
               gps.date = atoi(  strcpy( tempf,strtok(NULL, ",")));
               
               
               gps.magvar = atof(  strcpy( tempf,strtok(NULL, ",")));
               
        // parce_time(); 
        
          
         print_data();   
            
         //print_full();    
   }   
   
void print_full()   
    {
     for( int i = 0; i <=82; i ++)
        print("%c",RMC[i]);
    // print("\n");
    }      
void print_data()


    {
      
       print("gps sentance:   %s\n\n", gps.gpsname); //works
      
      print("zulu time:  %s\n\n", gps.gpstime); //works
      memmove(hrs,gps.gpstime,2);
      print("%s\n\n",hrs);
      
      memmove(min,gps.gpstime+1,2);
      print("%s\n\n",min); 
      
      
      print("fix:  %s\n\n", gps.fix); //works 
      
      
      print("Lattitude: %f %s\n\n", gps.lat,gps.latchar); //works
      
      
      print("Longitude:  %f  %s\n\n", gps.longitude, gps.longchar); //works
      
      
       print("Velocity:  %f\n\n", gps.speed); //works 
       
       
       print("Date:  %d\n\n", gps.date); //works 
       
       
        print("Magnitic Variation:  %f\n\n", gps.magvar); //works 
    //  pause(500); 
    //  print( HOME); //works
      
      
    //  print("");
     // print("latchar %s\n\n", gps.latchar); //works
    }    
    
    
    
void parce_time()


      {
        
        
        //strncpy(hrs[0],gps.gpstime),2);
        hrs[0] = gps.gpstime[0];
        
    }      